Taggle = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1")
local L = AceLibrary("AceLocale-2.2"):new("Taggle")


function Taggle:OnInitialize()
	Taggle:RegisterDB("TaggleDB")
	Taggle:RegisterDefaults("account", {
		friends = {},
		guildmates= {},
		trusted={},
		spamfilter={},
		spamfilter2={},
		chatprefix="Taggle>",
		keyword="cornemuse",
		showpass=true,
		filtersay=true,
		}
	)  
	
local options = { 
    type="group",
    args = {
			listfilters= {
				type="execute",
				name=L["List filters"],
				desc=L["List all filters"],
				func=function(v) 
					self:Print(L["Default filters:"])
					for k,v in pairs(self.db.account.spamfilter) do
						self:Print(v)
					end
					self:Print(L["Your filters:"])
					if self.db.account.spamfilter2=={} then self:Print("None")
					else
						for k,v in pairs(self.db.account.spamfilter2) do
							self:Print(k..". "..v)
						end
					end
				end
					,
			},
			
			addfilter	={
				type="text",
				name=L["Add a filter"],
				desc=L["Add a filter"],
				get=false,
		 	 set=function(v) table.insert(self.db.account.spamfilter2,v) self:Print(L["Filter added"]) return end,
		 	 usage="<your filter>",
		  },
		  
		  delfilter={
		 	 type="text",
		 	 name=L["Delete a filter"],
		 	 desc=L["Delete a filter using its index (list filters to get the index)"],
		 	 get=false,
		 	 set=function(v) self:Print(self.db.account.spamfilter2[tonumber(v)].. L[" removed."]) table.remove(self.db.account.spamfilter2,tonumber(v)) self:Print(L["Indexes changed, list them again before deleting another filter"]) return end,
		   usage="<flter index>",
		  },
		  
		  prefix={
		 		type="text",
		 		name=L["Prefix"],
		  	desc=L["Change the prefix used for your answers, be careful to be specific enough"],
		  	get=function() return self.db.account.chatprefix end,
				set=function(v) self.db.account.chatprefix=v return end,
				usage="Taggle>",
			},
			password={
		 		type="text",
		 		name=L["Password"],
		  	desc=L["Change the password used for trusting people"],
		  	get=function() return self.db.account.keyword end,
				set=function(v) self.db.account.keyword=v return end,
				usage="cornemuse",
			},
			showpass={
		 		type="toggle",
		 		name=L["Show Password"],
		  	desc=L["Show the password in the autoreply"],
		  	get=function() return self.db.account.showpass end,
				set=function(v) self.db.account.showpass=not self.db.account.showpass return end,
			},
			filtersay={
		 		type="toggle",
		 		name=L["Filter /say channel"],
		  	desc=L["Check the /say channel for spam too"],
		  	get=function() return self.db.account.filtersay end,
				set=function(v) self.db.account.filtersay=not self.db.account.filtersay return end,
			},
						
		}
}

Taggle:RegisterChatCommand({"/taggle"}, options)

end

function Taggle:OnEnable()
	local t={}
	table.insert(t,"http://")
	table.insert(t,"www")
	table.insert(t,"w w w")
	table.insert(t,"W W W")
	table.insert(t,"WWW")
	table.insert(t,".com")
	table.insert(t,".COM")
	table.insert(t,".net")
	table.insert(t,".NET")
	table.insert(t,".org")
	table.insert(t,".ORG")
	self.db.account.spamfilter=t
	
	self:Hook("ChatFrame_MessageEventHandler", "WhisperHandler", true)
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:BuildFriendList()
	self:BuildGuildList()
end

function Taggle:OnDisable()
	self:UnhookAll()
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:UnregisterEvent("GUILD_ROSTER_UPDATE")
end

function Taggle:WhisperHandler(event)
	if arg1 and arg1~="" then
		if self:isThisSpam(arg1) and event=="CHAT_MSG_WHISPER" then
		   if not self:isTrusted(arg2) then
          self:GetTrusted(arg2,1)
          arg1=""
          return
       end
		
		elseif string.sub(arg1,1,string.len(self.db.account.keyword))==self.db.account.keyword and event=="CHAT_MSG_WHISPER" then
		   self:GetTrusted(arg2,2)
		   return
    
		elseif string.sub(arg1,1,string.len(self.db.account.chatprefix))==self.db.account.chatprefix and event=="CHAT_MSG_WHISPER_INFORM" then
			return 
		elseif self:isThisSpam(arg1) and event=="CHAT_MSG_SAY" and self.db.account.filtersay and arg1~= UnitName("player") then arg1="" return
		end
	end
	if arg1~="" then return self.hooks["ChatFrame_MessageEventHandler"](event) end
end

function Taggle:GetTrusted(sender,i)
         if i==1 then
            self:Respond(L["This message has been detected as spam. You have to answer to this message using the password to become trusted."],arg2)
            if self.db.account.showpass then self:Respond(L["The password is: "]..self.db.account.keyword,arg2) end
            return
         end
         if i==2 then
            if self:isTrusted(sender) then self:Respond(L["You are already trusted."],arg2)
            else
                table.insert(self.db.account.trusted,sender)
                self:Respond(L["You are now trusted."],arg2)
                return
            end
         end
end


function Taggle:isThisSpam(message)
         local thisisspam=false
         for k,v in pairs(self.db.account.spamfilter) do
             if string.find(message,v) ~= nil then thisisspam=true end
         end
         return thisisspam
end

function Taggle:isTrusted(sender)
	local trusted=false

	-- check the friendlist
	for k,v in pairs(self.db.account.friends) do
		if sender==v then trusted=true end
	end

	-- check guildmates
	for k,v in pairs(self.db.account.guildmates) do
		if sender==v then trusted=true end
	end

	--check the built-in trusted list
	for k,v in pairs(self.db.account.trusted) do
		if sender==v then trusted=true end
	end
	
	--check the user trusted list
	if not self.db.account.trusted2=={} then 
		for k,v in pairs(self.db.account.trusted2) do
			if sender==v then trusted=true end
		end
	end

	return trusted
end


function Taggle:BuildFriendList()
         local nbfr = GetNumFriends()
         local friendlist={}
         for k=1,nbfr do
             local name, level, class, area, connected, status = GetFriendInfo(k)
             table.insert(friendlist,name)
         end
         self.db.account.friends=friendlist
end

function Taggle:BuildGuildList()
         GuildRoster()
end
function Taggle:GUILD_ROSTER_UPDATE()
         local nbgu = GetNumGuildMembers(true)
         local guildmates={}
         for k=1,nbgu do
             local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(k)
             table.insert(guildmates,name)
         end
         self.db.account.guildmates=guildmates
end

function Taggle:Respond(message,sender)
	SendChatMessage(self.db.account.chatprefix.." "..message, "WHISPER", nil, sender)
end